/***************************************************************************
				kledbutton.h - KLed widget for kommander
                             -------------------
		begin			: 11-5-2005
		copyright		: (C) Pedro Lopez-Cabanillas
		email			: plcl@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _HAVE_KLEDBUTTON_H_
#define _HAVE_KLEDBUTTON_H_

/* KDE INCLUDES */

/* QT INCLUDES */
#include <kled.h>
#include <qstring.h>
#include <qstringlist.h>

/* OTHER INCLUDES */
#include <kommanderwidget.h>

class QWidget;

class QShowEvent;
class KLedButton : public KLed, public KommanderWidget
{
	Q_OBJECT

	Q_PROPERTY(QString populationText READ populationText WRITE setPopulationText DESIGNABLE false)
	Q_PROPERTY(QStringList associations READ associatedText WRITE setAssociatedText DESIGNABLE false)
	Q_PROPERTY(bool KommanderWidget READ isKommanderWidget)

public:
	KLedButton(QWidget *a_parent, const char *a_name);
	~KLedButton();

	virtual QString widgetText() const;

	virtual bool isKommanderWidget() const;
	virtual void setAssociatedText(QStringList);
	virtual QStringList associatedText() const;
	virtual QString currentState() const;

	virtual QString populationText() const;
	virtual void setPopulationText(QString);

	QSize sizeHint () const;
	QSize minimumSizeHint () const;
	QSizePolicy sizePolicy () const;

	virtual QString handleDCOP(int function, const QStringList& args);
	virtual bool isFunctionSupported(int function);

public slots:
	virtual void setWidgetText(const QString &);
	virtual void populate();

signals:
	void widgetOpened();
	void widgetTextChanged(const QString &);
	void stateChanged( bool newState );	
	
protected:
	void showEvent( QShowEvent *e );
	void mousePressEvent ( QMouseEvent *e );

private:
	typedef std::map<KLed::State, QString> StateMap;
	static StateMap m_stateMap;
};

#endif
