/***************************************************************************
				kmdknob.h - A Knob widget for Kommander
                             -------------------
		begin			: 2005-10-01
		copyright		: (C) Pedro Lopez-Cabanillas
		email			: plcl@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _HAVE_KNOB_H_
#define _HAVE_KNOB_H_

/* KDE INCLUDES */

/* QT INCLUDES */
#include <qstring.h>
#include <qstringlist.h>

/* OTHER INCLUDES */
#include <kommanderwidget.h>
#include "knob_impl.h"

class QWidget;

class QShowEvent;
class Knob : public KnobImpl, public KommanderWidget
{
	Q_OBJECT

	Q_PROPERTY(QString populationText READ populationText WRITE setPopulationText DESIGNABLE false)
	Q_PROPERTY(QStringList associations READ associatedText WRITE setAssociatedText DESIGNABLE false)
	Q_PROPERTY(bool KommanderWidget READ isKommanderWidget)
	
public:
	Knob(QWidget *a_parent, const char *a_name);
	~Knob();

	virtual bool isKommanderWidget() const;
	virtual void setAssociatedText(QStringList);
	virtual QStringList associatedText() const;
	virtual QString currentState() const;

	virtual QString populationText() const;
	virtual void setPopulationText(QString);
	virtual QString widgetText() const;

	virtual QString handleDCOP(int function, const QStringList& args);
	virtual bool isFunctionSupported(int function);
	
public slots:
	virtual void setWidgetText(const QString &);
	virtual void populate();
signals:
	void widgetOpened();
	void widgetTextChanged(const QString &);
protected:
	void showEvent( QShowEvent *e );
private:
};

#endif
