#include <kommanderplugin.h>

/* WIDGET INCLUDES */
#include "knob.h"
#include "kledbutton.h"

class KaseqPlugin : public KommanderPlugin
{
public:
    KaseqPlugin();
    virtual QWidget *create( const QString &key, QWidget *parent = 0, const char *name = 0 );
};

KaseqPlugin::KaseqPlugin()
{
  const char *group = "Kaseq";
  addWidget("Knob", group, "");
  addWidget("Led", group, "");
}

QWidget *KaseqPlugin::create( const QString &key, QWidget *parent, const char *name )
{
  if (key == "Knob") return new Knob(parent, name);
  else if (key == "Led") return new KLedButton(parent, name);
  else return 0;
}

KOMMANDER_EXPORT_PLUGIN(KaseqPlugin)
